--factn

library ieee;
use ieee.std_logic_1164.all;
library ieee_proposed;
use ieee_proposed.fixed_float_types.all;
use ieee_proposed.float_pkg.all;

entity factn is
  generic(we: positive;
          wf: positive);
  port ( n : in integer range 0 to 13;
         data : out float(we downto -wf) );
end entity factn;

architecture behavioral of factn is
  type mem is array ( 0 to 13) of float(we downto -wf);
  constant my_rom : mem := (
    0  => to_float(1.0,we,wf),
    1  => to_float(1.0,we,wf),
    2  => to_float(2.0,we,wf),
    3  => to_float(6.0,we,wf),
    4  => to_float(24.0,we,wf),
    5  => to_float(120.0,we,wf),
    6  => to_float(720.0,we,wf),
    7  => to_float(5040.0,we,wf),
    8  => to_float(40320.0,we,wf),
    9  => to_float(362880.0,we,wf),
    10 => to_float(3628800,we,wf),
    11 => to_float(39916800.0,we,wf),
    12 => to_float(479001600.0,we,wf),
    13 => to_float(622702800.0,we,wf)
    --14 => to_float(87178291200.0,we,wf),
    --15 => to_float(1307674368000.0,we,wf)
    );
begin
   process (n)
   begin
       case n is
        when 0 => data <= my_rom(0);
        when 1 => data <= my_rom(1);
        when 2 => data <= my_rom(2);
        when 3 => data <= my_rom(3);
        when 4 => data <= my_rom(4);
        when 5 => data <= my_rom(5);
        when 6 => data <= my_rom(6);
        when 7 => data <= my_rom(7);
        when 8 => data <= my_rom(8);
        when 9 => data <= my_rom(9);
        when 10 => data <= my_rom(10);
        when 11 => data <= my_rom(11);
        when 12 => data <= my_rom(12);
        when 13 => data <= my_rom(13);
        --when 14 => data <= my_rom(14);
        --when 15 => data <= my_rom(15);
        when others => data <= (others=>'X');
      end case;
    end process;
end architecture behavioral;
