LIBRARY IEEE;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.all;

LIBRARY ieee_proposed;
use ieee_proposed.float_pkg.all;


ENTITY testbench_tanh is
END testbench_tanh;

ARCHITECTURE behavior of testbench_tanh is
  component tanh
  generic(
    we:positive;
    wf: positive
    );
  port(
    x: in std_logic_vector(we+wf downto 0);
    n: in std_logic_vector(3 downto 0);
    clk: in std_logic;
    start: in std_logic;
    sclr: in std_logic;
    z: out std_logic_vector(we+wf downto 0);
    rdy: out std_logic;
    underflow: out std_logic;
    overflow: out std_logic;
    invalid_op: out std_logic;
    divide_by_zero: out std_logic
    );
        
  end component;
      
  --Inputs
  constant we:positive:=5;
  constant wf:positive:=2;
  signal xfp: float(we downto -wf);
  signal x:std_logic_vector(we+wf downto 0);
  signal n:std_logic_vector(3 downto 0);
  signal clk,start,sclr,rdy,underflow,overflow,invalid_op,divide_by_zero: std_ulogic;
  signal z : std_logic_vector(we+wf downto 0);
  constant freq: time := 12.5 ns;
      
  begin
          xfp<=to_float(-0.67,xfp);
          x<=to_slv(xfp);
          n<="1111";
          
  tanh_0: tanh
      generic map(
        we=>we,
        wf=>wf
      )
      port map(
        x =>x,
        n=>n,
        z=>z,
        clk =>clk,
        start=>start,
        sclr=>sclr,
        rdy=>rdy,
        underflow=>underflow,
        overflow=>overflow,
        invalid_op=>invalid_op,
        divide_by_zero=>divide_by_zero
        );

  clk_gen: process
    begin 
      clk<='0' after freq,'1'after 2*freq;
      wait for 2*freq;
    end process clk_gen;
  
  tb: process
      begin
        
        wait for 25 ns;
        sclr<='1';
        start<='0';
        wait for 2*freq;
        sclr<='0';
        start<='1'after 20 ns,'0'after 40 ns;
        wait for 100*freq;
        sclr<='1';
        wait for 100 ns;
        
      end process;
  
  end;
  
